proc get_filename {filename} {
  global name test graph 

    set name $filename
    set output [gcl "set/file \"$name\""]
    testOutput $output
    set test [gcl "get 1 \"$name\""]
    set test [lindex $test 1] 
    if {[string match {* raw*} $test] == 1} { 
      set test "raw"
      $graph.but.display config -activebackground Green
      $graph.but.multiplot config -activebackground Green
      $graph.but.cell config -activebackground Green
      $graph.but.contour config -activebackground Green
      $graph.box.view config -activebackground Green
    } 
    if {[string match {* intermediate*} $test] == 1} {
      set test "raw"
      $graph.but.display config -activebackground Green
      $graph.but.multiplot config -activebackground Green
      $graph.but.cell config -activebackground Green
      $graph.but.contour config -activebackground Green
      $graph.box.view config -activebackground Green
    }
    if {[string match {* ASCII*} $test] == 1} {
      set test "ASCII"
      $graph.but.display config -activebackground Red
      $graph.but.multiplot config -activebackground Red
      $graph.but.cell config -activebackground Green
      $graph.but.contour config -activebackground Green
      $graph.box.view config -activebackground Green
    }
}

proc open {filename} {
global name specNum spec test graph
  if {[string match $filename 1] == 0} {
    set name $filename
  }
  if {[string match $name _] == 1} {
    errorMess "A FileName is not Specified"
  } else {
    if {[string match raw $test] == 0} {
      exec "dxnotepad" $name -bg grey -fg black &
      set name _
      set filename _
    } else {
      set output [gcl "set/file \"$name\""]
      testOutput $output
      getSpectra
    }
  }
} 

proc getSpectra {} {
  global specNum spec number
  set spec .findSpectra 
      catch {destroy $spec}
      toplevel $spec
      set number [gcl "printn get(\"NSP1\")"]
      set number [lindex $number 0]
      set number [string trim $number]
      tixControl $spec.spectra -label "Spectra Number: " -integer true \
	-variable specNum -min 1 -max $number -value 1
      button $spec.ok -text OK -command "testSpectra "
      button $spec.cancel -text Cancel -command "catch {destroy $spec}"
      pack $spec.cancel $spec.ok -side left -padx 0 -pady 50
      pack $spec.spectra -side top -padx 50 -pady 0
}

proc testSpectra {} {
  global spec name getSpectra specNum 
  set tmp [gcl "printn s($specNum)"]
  set tmp [lindex $tmp 0]
  set view .win
  catch {destroy .findSpectra}
  catch {destroy $view}
  toplevel $view
  wm title $view "$name spectra: $specNum"
  tixScrolledWindow $view.tmp -height 600 -width 600
  pack $view.tmp -expand yes -fill both
  set f [$view.tmp subwidget window]
  label $f.label -text $tmp -justify left
  pack $f.label -expand yes -fill both

  tixButtonBox $view.box -orientation horizontal
    $view.box add previous -text Previous -command "previous"
    $view.box add cancel -text Cancel -underline 0 -command "destroy $view" \
	-width 12
    $view.box add next -text Next -command "next"
    pack $view.box -side bottom -fill both -expand yes
  
}

proc previous {} {
  global specNum
  if {[string match $specNum 1] == 1} {
	errorMess {There are no previous spectra}
  } else {
    set specNum [expr $specNum - 1]
    testSpectra 
  }
}

proc next {} {
  global specNum number
  if {[string match $specNum $number] == 1} {
	errorMess "There are only $number spectra"
  } else {
    set specNum [expr $specNum + 1]
    testSpectra 
  }
}

proc getX {} {
  global specNum spec view tmp
  gcl "w=s($specNum)"
  set tmp [gcl "printn w.y"]  
}

proc Mark { x y W } {
    global state
    set state($W,obj) [$w find closest $x $y]
    set state($W,x) $x
    set state($W,y) $y
}

proc Drag { x y W } {
    global state
    set dx [expr $x - $state($W,x)]
    set dy [expr $y - $state($W,y)]
    $W move $state($W,obj) $dx $dy
    set state($W,x) $x
    set state($W,y) $y
}

proc multiplot {} {
  global name lcolour tcolour lwidth tsize start finish multi test number
  set multi .multiplotOpt
  catch {destroy $multi}
  toplevel $multi
  wm title $multi "Spectra Numbers"
  set number [gcl "printn get(\"NSP1\",\"$name\")"]
  set number [lindex $number 0]
  set number [string trim $number]
  
  frame $multi.con
  pack $multi.con -side top
  tixControl $multi.con.one -label "Spectra From: " -integer true \
	-variable start -min 1 -max $number -value 1

  tixControl $multi.con.two -label "Spectra To: " -integer true \
	-variable finish -min 1 -max $number -value $number

  pack $multi.con.one $multi.con.two -side left

  tixButtonBox $multi.box -orientation horizontal
$multi.box add ok -text OK -underline 0 -command {fileThere 1; destroy $multi} \
	-width 10
  $multi.box add cancel -text Cancel -underline 0 -command "destroy $multi" \
         -width 10
 
  pack $multi.box -side bottom -expand yes -fill x

}

proc fileThere {mark} {
  global name multi graph 
  if {[string len $name] == 0} {
    errorMess "A File has not been Specified"
  } else {
    display $name $mark 
  }
}

proc primCont {cell} {
  global name contourType_options contourType_label library test primary \
	 cellType_options cellType_labels

  after idle {.dialog1.msg config -wraplength 1i}
  set i [tk_dialog .dialog1 "Something" "$cell Not Yet Implemented" info 0 \
	 Ok]

#======================================================================	#
#======================================================================	#
#									#
#	This code does work, but the following functions		#
#	are not quite finished !!!					#
#									#
#======================================================================	#
#======================================================================	#
#
#  
#  if {[string match $test raw] == 1} {
#    drawRAWContour $cell
#  } else {
#    set primary .primaryContour
#    catch {destroy $primary}
#    toplevel $primary
#  wm title $primary "$cell Preliminaries"
#
#    if {[string match $cell cell] == 1} {
#      tixOptionMenu $primary.type -label "Cell Type: " -variable contourType
#      foreach opt $cellType_options {
#	$primary.type add command $opt -label $cellType_labels($opt)
#      }
#    } else {
#      tixOptionMenu $primary.type -label "Contour Type: " -variable contourType 
#      foreach opt $contourType_options {
#        $primary.type add command $opt -label $contourType_label($opt)
#      }
#    }
#    pack $primary.type -side top -expand yes -fill x
#
#    tixFileEntry $primary.library  -labelside left -label "Library File" \
#    	       -dialogtype tixExFileSelectDialog -variable library
#
#    tixFileEntry $primary.function -labelside left -label "Function Name" \
#    	       -dialogtype tixExFileSelectDialog -variable function
#    set tmp [tix filedialog tixExFileSelectDialog]
#    $tmp subwidget fsbox config -filetypes {
#            {{*}    {All files}}
#    	    {{*.so}	{Library Files}}
#	    {{*.f}	{Function Files}}
#      }
#
#    tixButtonBox $primary.box -orientation horizontal
#    $primary.box add ok -text Ok -command "contour {$cell}"
#    $primary.box add cancel -text Cancel -command "catch {destroy $primary}"
#
#    pack $primary.type $primary.library $primary.function $primary.box \
#         -side top -expand yes -fill x
#  }
#}

proc drawRAWContour {cell} {
  global name devNum
  set devNum [expr $devNum + 1]
  set rawCont .dev$devNum
  catch {destroy $rawCont}
  toplevel $rawCont
  wm title $rawCont "RAW Contour Plot"
  
  pgwindow $rawCont.p$devNum -width 600 -height 700 -background Black \
             -relief flat
    pack $rawCont.p$devNum
    set temp device$devNum
    set output [smalltalk "|tmp dev|
             Smalltalk at:#Udevice$devNum put: nil!
             Udevice$devNum _ (Device new: 'tk').
             gXUUgraphics at: #gXcurrentdevice put: (Udevice$devNum Open).
        ((gXUUgraphics at: #gXcurrentgraphics) addToDeviceList: Udevice$devNum).
               gXUUstatus _ 1.
               gXUUgraphics at: #gXcurrentpicture put: nil.
               gXUUgraphics at: #gXcurrentwindow put: nil!"]
    testOutput $output

  tixButtonBox $rawCont.box -orientation horizontal
    $rawCont.box add alter -text Alter      -command "disAlter {$rawCont}"
    $rawCont.box add cursor -text Cursor    -command "cursor {$rawCont}"
    $rawCont.box add hardcopy -text Hardcopy      -command "hardcopy {$rawCont}"
    $rawCont.box add zoom -text Zoom          -command "zoom {$rawCont} {$name}"
    $rawCont.box add redraw -text Redraw    -command "redraw {$rawCont} {$name}"
    $rawCont.box add cancel -text Cancel -command "cancel {$rawCont}"

    menubutton $rawCont.annotate -text Annotate -menu $rawCont.annotate.menu
    set m [menu $rawCont.annotate.menu]
    $m add command -label Graticule -command "axes {Graticule $rawCont}"
    $m add command -label Text -command "text {$rawCont}"

    pack $rawCont.box $rawCont.annotate -side right -expand yes -fill x
 
set output [gcl "set/file \"$name\"
     nx=get(\"NTC1\")
     ny=get(\"NSP1\")
     w=get(1:ny)
     win_scaled 0.2 0.8 0.2 0.8 w.x\[1\] w.x\[nx\] 1.0 ny*1.0"]
if {[string match $cell cell] == 1} {
    set output [gcl "col=read:ascii:columns(\"/usr/users/rla/genie/examples/report/rainbow.dat\", \"R,G,B\")
	table=allocate_colours(col.r,col.g,col.b,30,1.0,1.0)
   	cell/draw/smooth w.y table valmax=30.0
	deallocate_colours table=table "]
    testOutput $output
  } else {
     set output [gcl "contour/draw/sqrt w.y "]
     testOutput $output
  }
  gcl "axes/draw
       labels/draw \"Time-Of-Flight (\\gms)\" \"Spectrum Number\" size=1.5"
} 
 genie coordinates
        g_genieCoordinates
        tixLabelEntry .text.text -label Text:
        .text.text subwidget entry config -textvariable gw_text
        .text.text subwidget entry delete 0 end
        .text.text subwidget entry insert end ($x,$y)
        checkbutton .text.check -text "centre text" -variable gw_cent  
        .text.check select
        tixButtonBox .text.box -orientation horizontal
        .text.box add ok -text Ok -command "g_annotateOk $x $y \$gw_text \$gw_cent;\
            catch {destroy .text}"
        .text.box add help -text Help -command \
            {g_help "overview.htm#Plot Area Interactions"}
        .text.box add cancel -text Cancel -command "catch {destroy .text}"
        pack .text.text .text.check .text.box -side top -expand yes -fill x
        bind .text <Return> {.text.box.ok invoke}
    }
}

proc g_annotateOk {x y text cent} {
# called if the user Ok's the annotation
# x, and y are passed down from above
# text is the text string provided by the user
    global g_gd
    if {$cent == 1} {
        set output [gcl "text/draw/centre $x $y \"$text\" $g_gd(text_colour) \
            $g_gd(charsize) font=$g_gd(quality)"]
    } else {
        set output [gcl "text/draw $x $y \"$text\" $g_gd(text_colour) \
            $g_gd(charsize) font=$g_gd(quality)"]
    }
    g_testOutput $output
}

proc g_limits {} {
    global g_limits g_current
    set l .limits
    g_winPosition $l
    wm title $l "Change Limits"
    if {$g_limits(xmin) == "_"} {
        set x [g_getx $g_current]
        set y [g_gety $g_current]
        set g_limits(xmin) [gcl "print min(wa\[$g_current\]$x)" -out]
        set g_limits(xmax) [gcl "print max(wa\[$g_current\]$x)" -out]
        set g_limits(ymin) [gcl "print min(wa\[$g_current\]$y)" -out]
        set g_limits(ymax) [gcl "print max(wa\[$g_current\]$y)" -out]
    }
    button $l.auto -text "Auto Limits" -command g_limitsAuto
    foreach limit {xmin xmax ymin ymax} {
        tixLabelEntry $l.$limit -label "$limit : "
        $l.$limit subwidget entry config -textvariable gw_$limit
        $l.$limit subwidget entry delete 0 end
        $l.$limit subwidget entry insert end $g_limits($limit)
    }
    tixButtonBox $l.box -orientation horizontal
    $l.box add ok -text Ok -command "g_limitsOk \$gw_xmin \$gw_xmax \$gw_ymin \$gw_ymax;\
        catch {destroy $l}"
    $l.box add help -text Help -command {g_help limits.htm}
    $l.box add cancel -text Cancel -command "catch {destroy $l}"
    pack $l.auto $l.xmin $l.xmax $l.ymin $l.ymax $l.box -expand yes -fill x
    bind $l <Return> "$l.box.ok invoke"
}

proc g_limitsAuto {} {
    global g_current
    upvar gw_xmin gw_xmin
    upvar gw_xmax gw_xmax
    upvar gw_ymin gw_ymin
    upvar gw_ymax gw_ymax
    set x [g_getx $g_current]
    set y [g_gety $g_current]
    set gw_xmin [gcl "print min(wa\[$g_current\]$x)" -out]
    set gw_xmax [gcl "print max(wa\[$g_current\]$x)" -out]
    set gw_ymin [gcl "print min(wa\[$g_current\]$y)" -out]
    set gw_ymax [gcl "print max(wa\[$g_current\]$y)" -out]    
}

proc g_limitsOk {xmin xmax ymin ymax} {
    global g_limits
    set g_limits(xmin) $xmin
    set g_limits(xmax) $xmax
    set g_limits(ymin) $ymin
    set g_limits(ymax) $ymax
}

proc g_genieCoordinates {} {
    global g_limits
    upvar x x
    upvar y y
# find the width and height of the tk canvas
    set xMax [winfo width .p1]
    set yMax [winfo height .p1]
# get limits
    if {$g_limits(xminlog) == 1} {
        set lxMin [expr log10($g_limits(xmin))]
    } else {
        set lxMin $g_limits(xmin)
    }
    if {$g_limits(xmaxlog) == 1} {
        set lxMax [expr log10($g_limits(xmax))]
    } else {
        set lxMax $g_limits(xmax)
    }
    if {$g_limits(yminlog) == 1} {
        set lyMin [expr log10($g_limits(ymin))]
    } else {    
        set lyMin $g_limits(ymin)
    }
    if {$g_limits(ymaxlog) == 1} {
        set lyMax [expr log10($g_limits(ymax))]
    } else {    
        set lyMax $g_limits(ymax)
    }
    set dxMin $g_limits(dxmin)
    set dxMax $g_limits(dxmax)
    set dyMin $g_limits(dymin)
    set dyMax $g_limits(dymax)    
# change y to fit with the genie coordinate system
    set y [expr $yMax - $y]
# adjust values to allow for the border
    set x [expr $x - ($xMax * $dxMin)]
    set y [expr $y - ($yMax * $dyMin)]
    set xMax [expr $xMax * ($dxMax - $dxMin)]
    set yMax [expr $yMax * ($dyMax - $dyMin)]
# finally convert the adjusted canvas coordinates to genie coordinates
    set x [expr ((($lxMax - $lxMin) / $xMax) * $x) + $lxMin]
    set y [expr ((($lyMax - $lyMin) / $yMax) * $y) + $lyMin]
}    

proc g_coordinates {x y} {
    g_genieCoordinates
    .b.coord.x config -text "x: $x"
    .b.coord.y config -text "y: $y"
}

proc g_setTrace {name1 name2 op} {
    global g_current g_current_set
    set g_current_set wa\[$g_current\]
}                

proc g_getSet {args} {
    global g_set g_current
    set p1 [lindex $args 0]
    if {[llength $args] == 1} {
        if [catch {set w $g_set($p1,wk)}] {
            set w $g_set($g_current,wk)
            set f $g_set($g_current,$p1)
            return wa\[$w\]$f    
        } else {
            return wa\[$w\]
        }
    } else {
        set w $g_set($p1,wk)
        set p2 [lindex $args 1]
        set f $g_set($p1,$p2)
        return wa\[$w\]$f
    }
}

proc g_setCount {} {
    global g_set
    set size [array size g_set]
    return [expr $size/10]
}

proc g_nextSet {} {
    return [g_nextW]
}

proc g_nextW {} {
    return [gcl "print count+1" -out]
}

proc g_createSet {} {
    set s [gcl "count = count + 1;print count" -out]
# make sure g_set is complete
    g_setw $s $s
    g_setTemplate $s Default
    g_setb $s _
    g_setf $s _
    gcl "[g_getSet $s] = fields()"
    return $s
}

proc g_copySet {{set 0}} {
    global g_current
    if {$set == 0} {
        set set $g_current
    }
    set s [gcl "count = count + 1;print count" -out]
    g_setw $s $s
    gcl "[g_getSet $s] = [g_getSet $set]"
    g_setTemplate $s [g_getTemplate $set]
    g_setb $s _
    g_setf $s _    
    return $s
}

proc g_registerSet {set} {
    global g_current
# update g_current
    set g_current $set
# refresh status line
    g_setinfo _ "$g_current,block" _
# check the state
    g_checkState
}

proc g_setLimits {args} {
    global g_limits
    if {[llength $args] == 0} {
        gcl "tmp = __graphics.currentwindow"
        set g_limits(xmin) [smalltalk "gXtmp lxMin prn!" -out]
        set g_limits(xmax) [smalltalk "gXtmp lxMax prn!" -out]
        set g_limits(ymin) [smalltalk "gXtmp lyMin prn!" -out]
        set g_limits(ymax) [smalltalk "gXtmp lyMax prn!" -out]
        set g_limits(dxmin) [smalltalk "gXtmp xMin prn!" -out]
        set g_limits(dxmax) [smalltalk "gXtmp xMax prn!" -out]
        set g_limits(dymin) [smalltalk "gXtmp yM